package org.dromara.web.service;


import org.dromara.common.core.domain.R;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.web.domain.bo.ChargeRecordBo;
import org.dromara.web.domain.vo.ChargeRecordVo;

import java.util.Collection;
import java.util.List;

/**
 * 收费记录Service接口
 *
 * @author Lion Li
 * @date 2025-08-06
 */
public interface IChargeRecordService {

    /**
     * 查询收费记录
     *
     * @param id 主键
     * @return 收费记录
     */
    ChargeRecordVo queryById(Long id);

    /**
     * 分页查询收费记录列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 收费记录分页列表
     */
    TableDataInfo<ChargeRecordVo> queryPageList(ChargeRecordBo bo, PageQuery pageQuery);

    /**
     * 查询符合条件的收费记录列表
     *
     * @param bo 查询条件
     * @return 收费记录列表
     */
    List<ChargeRecordVo> queryList(ChargeRecordBo bo);

    /**
     * 新增收费记录
     *
     * @param bo 收费记录
     * @return 是否新增成功
     */
    Boolean insertByBo(ChargeRecordBo bo);

    /**
     * 修改收费记录
     *
     * @param bo 收费记录
     * @return 是否修改成功
     */
    Boolean updateByBo(ChargeRecordBo bo);

    /**
     * 校验并批量删除收费记录信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    TableDataInfo<ChargeRecordVo> queryInvoicePageList(PageQuery pageQuery);

    R totalize();
}
